IncludeScript("murdermystery/RoleController.nut")
ClearGameEventCallbacks()
liveplycount 			<- 0
toggle 					<- false
::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
}

const RETHINK_TIME = 1
function worldwatch() {//printl("world watch running")
	liveplycount = 0
	for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++){
    	local player = PlayerInstanceFromIndex(i)
    	if (player != null && NetProps.GetPropInt(player, "m_lifeState") == 0){
			liveplycount = liveplycount + 1
		}
	}

	local roundwin = Entities.FindByName(null, "game_round_win_blu")
    if (liveplycount <= 1 && GetRoundState() == 4 && IsInWaitingForPlayers() != true && InMatchStartCountdown() != true) {
		//printl("round end due to low player count")
		local roundend = SpawnEntityFromTable("game_round_win", {
                TeamNum         = 3, // 2 for red, 3 for blue, 0 for none
                switch_teams    = 0,
                force_map_reset = 1,
        })
		foreach (player in murderers) {
		if (player != null) {player.ForceChangeTeam(3, true)} //errored 
		}
		Convars.SetValue("tf_gravetalk", 1)
		Convars.SetValue("mp_respawnwavetime", 1)
		EntFireByHandle(roundend, "RoundWin", "", 0, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
	}
	/*else if (liveplycount == 2 && toggle == false) {
		toggle = true
		local player 	= Entities.FindByClassname(null, "player")
		local sapper 	= NetProps.GetPropEntityArray(player, "m_hMyWeapons", 2)
		EntFireByHandle(sapper, "targetname", "target", 0, player, player)
		printl("sapper name is " + sapper.GetName())
		local prop = SpawnEntityFromTable("prop_dynamic", {
			targetname 	= "prop",
			origin 		= player,
			parentname 	= player,
			model 		= "models/props_gameplay/ball001.mdl",
			}
		)
		local playerglow = SpawnEntityFromTable("tf_glow", {
			GlowColor 	= "49 255 63 170",
			target 		= "target",
			Mode 		= "0",
			}
		)
	}*/
    return RETHINK_TIME
}

function OnGameEvent_player_death(params){
	local stats = Entities.FindByClassname(null, "tf_player_manager")
	local deadplayer 	= GetPlayerFromUserID(params.userid)
	local deadplayergun = NetProps.GetPropEntityArray(deadplayer, "m_hMyWeapons", 0)
	if (NetProps.GetPropBool(self, "m_bForcedSkin") != false) {NetProps.SetPropBool(self, "m_bForcedSkin", false)}
	AddThinkToEnt(deadplayer, null)
	deadplayer.ValidateScriptScope()
	deadplayer.GetScriptScope().MyRole 	<- "spec"
	deadplayer.GetScriptScope().MyClass <- "null"

	//gun drop on death
	if (deadplayergun != null) {
		SpawnEntityFromTable("prop_physics_override",{
			targetname  = "dropped_gun",
			Model       = "models/weapons/w_models/w_revolver.mdl",
			solid       = 6,
			modelscale 	= 1.2,
			origin      = deadplayer,
			angles      = "0 0 0",
			vscripts    = "murdermystery/RoleController.nut",
			thinkfunction = "droppedgunthink",
			spawnflags = 4,
			}
		)
	}
	foreach (i, player in murderers) {
		if(params.userid == GetPlayerUserID(player)) {
			murderers.remove(i)
			if (murderers.len() <= 0) {
				//printl("round end due to murderers dying")
				local roundend = SpawnEntityFromTable("game_round_win", {
    	    	        TeamNum         = 2, // 2 for red, 3 for blue, 1 for spec
    	    	        switch_teams    = 0,
    	    	        force_map_reset = 1,
    	    		}
				)
				if (player != null && player.GetTeam() != 1) {player.ForceChangeTeam(3, true)}
				EndRoundConvars()
				EntFireByHandle(roundend, "RoundWin", "", 0.1, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
			}
		}
	}
}

function TimeRanOut() {
	local roundend = SpawnEntityFromTable("game_round_win", {
            TeamNum         = 2, // 2 for red, 3 for blue, 0 for none, 1 ?
            switch_teams    = 0,
            force_map_reset = 1,
    })
	foreach (player in murderers) {
	if (player != null && player.GetTeam() != 1) {player.ForceChangeTeam(3, true)}
	}
	EndRoundConvars()
	EntFireByHandle(roundend, "RoundWin", "", 0.1, roundend, roundend); EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
}

function OnPostSpawn() {
	Convars.SetValue("mp_friendlyfire", 	1)
	Convars.SetValue("mp_autoteambalance", 	0)
	Convars.SetValue("tf_dropped_weapon_lifetime", 	0)
	Convars.SetValue("sv_alltalk", 			1)
}

//force class change
function OnGameEvent_player_spawn(params){
	local respawnedplayer = GetPlayerFromUserID(params.userid)
	respawnedplayer.ValidateScriptScope()
	if (respawnedplayer != null && params.team == 0 ){
		respawnedplayer.GetScriptScope().karma 		<- 80
		respawnedplayer.GetScriptScope().MyRole 	<- "spec"
		respawnedplayer.GetScriptScope().MyClass 	<- "null"
	}
	if (respawnedplayer != null && params.team != 0 ){
		respawnedplayer.ForceChangeTeam(2, true)
		respawnedplayer.SetPlayerClass(8)
		respawnedplayer.Regenerate(true)
		respawnedplayer.GetScriptScope().MyRole 	<- "Bystander"
		respawnedplayer.GetScriptScope().MyClass 	<- "DefaultBystanderClass"
		local respawnedplayergun 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 0)
		local respawnedplayerknife 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 1)
		local respawnedplayersapper = NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 2)
		local respawnedplayerpda 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 3)
		local respawnedplayerinvis 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 4)
		if (respawnedplayergun		!= null) {respawnedplayergun.Kill()}
		if (respawnedplayerknife	!= null) {respawnedplayerknife.Kill()}
		if (respawnedplayerpda		!= null) {respawnedplayerpda.Kill()}
		if (respawnedplayerinvis	!= null) {respawnedplayerinvis.Kill()}
		respawnedplayer.Weapon_Switch(respawnedplayersapper)
		NetProps.SetPropInt(respawnedplayer, "m_nForcedSkin", 0)
		if (respawnedplayer.GetScriptThinkFunc() != null) {
			AddThinkToEnt(respawnedplayer, null)
			local spawnedply_cosmetic = null
			while(spawnedply_cosmetic = Entities.FindByClassname(spawnedply_cosmetic, "tf_wearable")){
				if (spawnedply_cosmetic.GetOwner() == respawnedplayer) {
					spawnedply_cosmetic.SetTeam(respawnedplayer.GetTeam())
				}
			}
		}
		if (respawnedplayer.GetScriptScope().karma <= 99) {
			respawnedplayer.GetScriptScope().karma = respawnedplayer.GetScriptScope().karma + 2
		}
	}
}

//killfeed mod
function OnScriptHook_OnTakeDamage(params) {
	params.attacker.ValidateScriptScope()
	params.const_entity.ValidateScriptScope()
	if (params.attacker.GetClassname() == "player" && params.const_entity.GetClassname() == "player") {
		if (GetPlayerUserID(params.attacker) != GetPlayerUserID(params.const_entity)) {
			if (params.attacker.GetScriptScope().MyRole == "Sheriff") {
				if (params.const_entity.GetScriptScope().MyRole == "Bystander") {
					params.attacker.TakeDamageEx(params.attacker, params.attacker, params.attacker, params.attacker.GetOrigin(), params.attacker.GetOrigin(), 999, 1);
					if (params.attacker.GetScriptScope().karma <= 60 && params.damage >= params.const_entity.GetHealth()) {params.damage = params.const_entity.GetHealth() - 1};
					params.attacker.GetScriptScope().karma = params.attacker.GetScriptScope().karma - 20;
				}
				else if (params.const_entity.GetScriptScope().MyRole == "Sheriff") {
					params.damage = params.const_entity.GetHealth() - 1
				}
				//else if (params.const_entity.GetScriptScope().MyRole == "Murderer") {}
			}
			else if (params.attacker.GetScriptScope().MyRole == "Murderer") {
				if (params.const_entity.GetScriptScope().MyRole == "Murderer") {
					max_damage = params.const_entity.GetHealth()-1
				}
				//else if (params.const_entity.GetScriptScope().MyRole == "Sheriff") {}
			}
		}
	}
	params.attacker = params.const_entity
}

function OnGameEvent_player_disconnect(params) {
	local DCPlayer = params.userid
	
}

//commands
function OnGameEvent_player_say(params) {
	GetPlayerFromUserID(params.userid).ValidateScriptScope()
	if (params.text == "!commands") {
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "\x07ffffffListing GameMode Commands")
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "\x07ffff00 - \x07ffffff!setclass -(to be implamented)")
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "\x07ffff00 - \x07ffffff!getclasslist -(to be implamented)")
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "\x07ffff00 - \x07ffffff!karma")
	}
	else if (params.text == "!setclass*") {
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "yet to be added")
	}
	else if (params.text == "!getclasslist*") {
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "yet to be added")
		//if (MurdererRolesList.len() != 0 && params.text == "!getclasslist murderer*") {MurdererRolesList}
	}
	else if (params.text == "!karma") {
		ClientPrint(GetPlayerFromUserID(params.userid), 3, "your karma level is [" + GetPlayerFromUserID(params.userid).GetScriptScope().karma + "]")
	}
}

//rps force kill
function OnGameEvent_rps_taunt_event(params) {
	local winner = params.winner
	local loser = params.loser
	if (loser.GetScriptScope().MyRole == "murderer") {
		loser.TakeDamageEx(loser, winner, winner, winner.GetOrigin(), winner.GetOrigin(), 999, 1)
	}
	else if (winner.GetScriptScope().MyRole == "murderer") {
		loser.TakeDamageEx(loser, winner, winner, winner.GetOrigin(), winner.GetOrigin(), 999, 1)
	}
}

function OnGameEvent_player_score_changed(params) {
	local player = params.player
	local delta = params.delta
}
__CollectGameEventCallbacks(this)