IncludeScript("murdermystery/artifact_system.nut")
IncludeScript("murdermystery/roles/Bystanders.nut")
IncludeScript("murdermystery/roles/Murderers.nut")
IncludeScript("murdermystery/roles/Sheriffs.nut")
/* TO DO LIST 
	-class system 				[/]
	-option menu				[ ]
	-karma						[/]
	-last player outline		[ ]
*/

::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
 }
::playerlist 			<- []
droppedgun_check_radius <- 110
::StartRoundConvars 	<- function() {
	Convars.SetValue("mp_respawnwavetime", 	999)
	Convars.SetValue("tf_gravetalk", 		0)
 }
::EndRoundConvars 		<- function() {
	Convars.SetValue("mp_respawnwavetime", 	1)
	Convars.SetValue("tf_gravetalk", 		1)
 }

//gamemode roles and role asignment
function giveroles(){
	StartRoundConvars()
	ClientPrint(null, 3, "\x07FFFF76   THE ROUND HAS STARTED.")
	ClientPrint(null, 3, "\x07E10000murderers\x07FFFFFF must kill all\x0700D500 bystanders\x07FFFFFF and\x070000F0 sheriffs\x07FFFFFF to win,")
	ClientPrint(null, 3, "\x0700D500bystanders\x07FFFFFF must survive and find artifacts( sapper gibs) to aquire a gun")
	ClientPrint(null, 3, "\x070000F0sheriffs\x07FFFFFF must protect the\x0700D500 bystanders\x07FFFFFF by shooting the\x07E10000 murderers")
	ClientPrint(null, 3, "\x07a4a4a4 (the living cannot hear the regrets of the dead)")
	
	for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++){
    	local player = PlayerInstanceFromIndex(i)
    	if (player == null) continue
		playerlist.append(player)
		player.SetCurrency(0)
	}
	
	local playercount = playerlist.len()
	if (SheriffRolesList.len() >= 2) {SheriffRolesList(RandomInt(0, playerlist.len() - 1) ) }
	else{DefaultSheriffClass()}
	if (MurdererRolesList.len() >= 2) {MurdererRolesList(RandomInt(0, playerlist.len() - 1) ) }
	else{DefaultMurdererClass()}
	playercount = playercount - 7
	while(playercount >= 7){
		if (SheriffRolesList.len() >= 2) {SheriffRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultSheriffClass()}
		if (MurdererRolesList.len() >= 2) {MurdererRolesList(RandomInt(0, playerlist.len() - 1) ) }
		else{DefaultMurdererClass()}
		playercount = playercount - 7
	}
	while(playerlist.len() >= 1){//bystanders
		if (BystanderRolesList.len() >= 2) {
			BystanderRolesList(RandomInt(0, playerlist.len() - 1))
		}
		else{DefaultBystanderClass()}
	}
}

//dropped gun think script
const RETHINK_TIME = 1
function droppedgunthink(){
	local nearbyplayer 		= Entities.FindByClassnameNearest("player", self.GetOrigin(), droppedgun_check_radius)
	local nearbyplayergun 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
	local nearbyplayerknife = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)

	//gives bystanders gun
	if (nearbyplayer != null) {
		if (nearbyplayergun != null || nearbyplayerknife != null) {
		}
		else{
			nearbyplayer.Regenerate(true)
			local nearbyplayergun 		= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
			local nearbyplayerknife 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)
			local nearbyplayersapper 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 2)
			local nearbyplayerpda 		= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 3)
			local nearbyplayerinvis 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 4)
			nearbyplayer.Weapon_SetLast(nearbyplayersapper)
			if (nearbyplayerinvis  	!= null) {nearbyplayerinvis.Kill()}
			if (nearbyplayerpda  	!= null) {nearbyplayerpda.Kill()}
			if (nearbyplayerknife 	!= null) {nearbyplayerknife.Kill()}
			nearbyplayergun.AddAttribute("damage bonus", 10, -1)
			nearbyplayergun.AddAttribute("Reload time decreased", 4.5, -1)
			nearbyplayergun.AddAttribute("fire rate penalty", 1, -1)
			nearbyplayergun.AddAttribute("maxammo secondary increased", 10, -1)
			nearbyplayergun.AddAttribute("mod max primary clip override", 1, -1)
			nearbyplayergun.AddAttribute("cloak consume rate decreased", 1000, -1)
			nearbyplayergun.AddAttribute("cannot disguise", 1, -1)
			nearbyplayergun.SetClip1(1)
			nearbyplayer.RemoveDisguise()
			SendToConsole("slot2")
			self.Kill()
		}
	}
    return RETHINK_TIME
}